function [val,ind]	=	PicDetect(s,seuil)
%PicDetect  Dtection des pics d'un signal
% 	[val,ind] = PicDetect(s,seuil) dtermine les indices et valeurs 
%	des pics prsents dans le signal s,  partir d'un certain
%	seuil (% du maximum de s, compris entre 0 et 1)
%	(valeur 0 par dfaut). Si n0 est prcise  la place du
%	seuil, la dtection s'effectue  raison d'un pic par tranche de n0.

%	Auteur : Nathalie Henrich, 16/07/00.
%	$Rvision: 03/08/00, 06/09/01

if nargin == 1
   seuil = 0;
end

if seuil <= 1

% calcul de la drive et diffrence entre signaux dcals de 1
sd = diff(s);
s1 = sd(1:length(sd)-1);
s2 = sd(2:length(sd));

% dtection des points d'inflexion
ind = find((sign(s1.*s2)==-1)&(sign(s2)<0));
ind = ind + 1;
val = s(ind);

% dtection des pics au-dessus du seuil
indpic = find(val>=seuil*max(s));

ind = ind(indpic);
val = val(indpic);

else
  n0 = seuil;
  ind = [];
  val = [];
  [smax,indmax] = max(s(1:min([fix(3*n0/2) length(s)])));
  
  if indmax > fix(1.1*n0)
    [smax,indpic] = max(s(1:fix(1.1*n0))); 
  else
    indpic = indmax;
  end
  ind(1) = indpic;
  
  i = 1;
  while (ind(i)+fix(1.1*n0))<length(s)
    i = i+1;
    [smax,indpic] = max(s(ind(i-1)+fix(n0/2):min(length(s),ind(i-1)+fix(3*n0/2))));     
    ind(i) = indpic + ind(i-1)+fix(n0/2) -1;
  end
  
  val = s(ind);
end
